Alter TAble tabDokumente alter Column DocID nvarchar(27) not null;
GO

/****** Object:  StoredProcedure [dbo].[spDokumentAlsNeueVersionEinfuegen]    Script Date: 27.11.2019 17:04:05 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER PROCEDURE [dbo].[spDokumentAlsNeueVersionEinfuegen]
@AlteDocID nvarchar(27),
@NeueDocID nvarchar(27),
@DokNameOriginalNeu nvarchar(255),
@DokNameInternNeu nvarchar(255),
@EUser int,
@ZipFileNeu nvarchar(250),
@DatumLetzteAenderungNeu datetime,
@DokumentVersionNeu int,
@MutterDokument nvarchar(255),
@UploadDurch int

AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
INSERT INTO tabDokumente
             (DocID, Art, ZugehoerigerKey, Bereich, Register, Sortierung, Besonderheit, DokNameOriginal, DokNameIntern, 
			 EUser, EDatum, Element, ZipFile, DokumentVersion, EngagementID, MutterDokument, DatumLetzteAenderung, UploadDurch, UploadAm, PruefungsID)
SELECT        @NeueDocID AS NeueDocID, Art, ZugehoerigerKey, Bereich, Register, Sortierung, Besonderheit, @DokNameOriginalNeu AS DokNameOriginalNeu, @DokNameInternNeu AS DokNameInternNeu, 
              @EUser as EUser, getdate(), Element, @ZipFileNeu AS ZipFileNeu, @DokumentVersionNeu AS DokumentVersionNeu, EngagementID, @MutterDokument as MutterDokument, 
			  @DatumLetzteAenderungNeu AS DatumLetzteAenderungNeu, @UploadDurch, getdate(), PruefungsID
FROM            tabDokumente AS D
WHERE        (DocID = @AlteDocID)

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumentEinfuegen]    Script Date: 22.11.2019 18:01:23 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [dbo].[spDokumentEinfuegen]
@DocID nvarchar(27),
@Art int,
@Register int,
@ZugehoerigerKey nvarchar(50),
@Bereich nvarchar(250),
@Sortierung nvarchar(50),
@DokNameOriginal nvarchar(255),
@DokNameIntern nvarchar(255),
@EUser int,
@Besonderheit nvarchar(3),
@Element nvarchar(50),
@ZipFile nvarchar(250),
@EngagementID nvarchar(17),
@DatumLetzteAenderung datetime,
@DokumentVersion int,
@MutterDokument nvarchar(255),
@UploadDurch int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
INSERT INTO [dbo].[tabDokumente]
           ([DocID]
		   ,[Art]
		   ,[Register]
		   ,[Sortierung]
           ,[ZugehoerigerKey]
           ,[Bereich]
           ,[DokNameOriginal]
           ,[DokNameIntern]
           ,[EUser]
           ,[EDatum]
		   ,[Besonderheit]
		   ,[Element]
		   ,[ZipFile]
		   ,[EngagementID]
		   ,[DatumLetzteAenderung]
		   ,[DokumentVersion]
		   ,[MutterDokument]
		   ,[UploadDurch]
		   ,[UploadAm]
		   ,[PruefungsID])
     VALUES
	 (@DocID, @Art, @Register,  @Sortierung, @ZugehoerigerKey, @Bereich, @DokNameOriginal, @DokNameIntern, @euser, 
	   getdate(), @Besonderheit, @Element, @ZipFile, @EngagementID, @DatumLetzteAenderung, @DokumentVersion, @MutterDokument, @UploadDurch, 
	   Getdate(), left(@zugehoerigerKey,12))

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumentAlsNeueVersionEinfuegen]    Script Date: 22.11.2019 18:01:58 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER PROCEDURE [dbo].[spDokumentAlsNeueVersionEinfuegen]
@AlteDocID nvarchar(27),
@NeueDocID nvarchar(27),
@DokNameOriginalNeu nvarchar(255),
@DokNameInternNeu nvarchar(255),
@EUser int,
@ZipFileNeu nvarchar(250),
@DatumLetzteAenderungNeu datetime,
@DokumentVersionNeu int,
@MutterDokument nvarchar(255),
@UploadDurch int

AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
INSERT INTO tabDokumente
             (DocID, Art, ZugehoerigerKey, Bereich, Register, Sortierung, Besonderheit, DokNameOriginal, DokNameIntern, 
			 EUser, EDatum, Element, ZipFile, DokumentVersion, EngagementID, MutterDokument, DatumLetzteAenderung, UploadDurch, UploadAm, PruefungsID)
SELECT        @NeueDocID AS NeueDocID, Art, ZugehoerigerKey, Bereich, Register, Sortierung, Besonderheit, @DokNameOriginalNeu AS DokNameOriginalNeu, @DokNameInternNeu AS DokNameInternNeu, 
              @EUser as EUser, getdate(), Element, @ZipFileNeu AS ZipFileNeu, @DokumentVersionNeu AS DokumentVersionNeu, EngagementID, @MutterDokument as MutterDokument, 
			  @DatumLetzteAenderungNeu AS DatumLetzteAenderungNeu, @UploadDurch, getdate(), PruefungsID
FROM            tabDokumente AS D
WHERE        (DocID = @AlteDocID)

END
gO


/****** Object:  StoredProcedure [dbo].[spDokumenteGetDocID]    Script Date: 22.11.2019 17:33:35 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
ALTER PROCEDURE [dbo].[spDokumenteGetDocID]
@Art int,
@PruefungsID nvarchar(12),
@Benutzer int

AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
Select Max(DocID) as HKey from tabDokumente where Art = @Art and PruefungsID = @PruefungsID and EUser = @Benutzer
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumente5BereichundSortierung]    Script Date: 27.11.2019 17:02:56 ******/
SET ANSI_NULLS ON

SET QUOTED_IDENTIFIER ON

IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spDokumente5BereichundSortierung]') AND type in (N'P', N'PC'))
BEGIN
EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE [dbo].[spDokumente5BereichundSortierung] AS' 
END
GO

ALTER PROCEDURE [dbo].[spDokumente5BereichundSortierung]
@ZugehoerigerKey nvarchar(50)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
Select        tabPruefungsfall.HauptKNEName + ' - ' + KAT.Katalogname + ' ' + K.KategorieKZ + ' ' + H.HandlungsKZ + ' ' + H.HStichwort AS Bereich,         
'005' + tabPruefungsfall.HauptKNEName + K.KategorieKZ + H.HandlungsKZ AS Sortierung, '' AS Besonderheit
FROM            tabKategorie AS K INNER JOIN
                         tabHandlungen AS H ON K.KID = H.KID AND K.EngagementID = H.EngagementID INNER JOIN
                         tabPruefungsfall INNER JOIN
                         tabKataloge AS KAT ON tabPruefungsfall.EngagementID = KAT.EngagementID ON K.KATID = KAT.KATID 
						 AND K.EngagementID = KAT.EngagementID
						 Where H.HID = @ZugehoerigerKey
END
GO

Update _tabVersion set DBVersion = '5.99', DBDate = '27.11.2019'
GO